
import java.util.*;

/**
  * FormCData	Class
  */


public class FormCData {

    FormCDataParser fc;
    FormCHtml fch;

    String formActionURL = "http://localhost:8080/examples/servlet/FormC";

    int keyIndex;
    String keyTerm;
    String keyCourse;
    String dataInstructor;
    String dataStudents[];

    /**
      * FormCData() Constructor 
      */

    public FormCData() {
        fc  = new FormCDataParser(FileUtil.openInputFile
                                  (FileUtil.getFile("FormC.Property")));

        fch = new FormCHtml();

    }

    /**
      * getDefaultFormC() Constructor 
      *
      * @return        String		    html
      */

    public String getDefaultFormC() {

        return(fch.formCSelect(fc.getTerm(), fc.getCourse(),
                               fc.getSection(), formActionURL));

    }

    /**
      * getSelectFormC() Constructor 
      *
      * @parm 			String			selectedTerm
      * @parm 			String			selectedCourse
      * @parm 			String			selectedInstructor
      * @return        String		    html
      */

    public String getSelectFormC(String selTerm, String selCourse,
                                 String selSection) {

        StringBuffer selection = new StringBuffer();

        selection.append(selTerm);
        selection.append(" ");
        selection.append(selCourse);
        selection.append(" ");
        selection.append(selSection);


        int index = 0;
        boolean dataExists = false;

        for (Enumeration e = (fc.getCourseKey()).elements();
                e.hasMoreElements(); index++) {

            if (selection.toString().equals((String)e.nextElement())) {
                keyIndex = index;
                dataExists = true;
                break;
            }
        }

        if (dataExists) {

            Vector inst = (Vector)(fc.getCourseInstructor()).elementAt(index);
            String selInstructor = new String();
            index = 0;

            for (Enumeration e = inst.elements();
                    e.hasMoreElements();)  {
                selInstructor = (String)e.nextElement();

            }


            Vector sv = (Vector)(fc.getCourseStudents()).elementAt(index);
            String selStudents[] = new String[sv.size()];
            index = 0;

            for (Enumeration e = sv.elements();
                    e.hasMoreElements(); index++) {
                selStudents[index] = (String)e.nextElement();

            }

            keyTerm        = selTerm;
            keyCourse      = selCourse;
            dataInstructor = selInstructor;
            dataStudents   = selStudents;

            return(fch.formC(selTerm, selCourse, selInstructor,
                             selStudents, formActionURL));
        }

        return null;

    }



    /**
      * getDisplayFormC() Constructor 
      *
      * @return        String		    html
      */

    public String getDisplayFormC(String [] fieldNames,
                                  String [] fieldValues) {


        return(fch.formCData(keyTerm, keyCourse, dataInstructor,
                             dataStudents, fieldNames, fieldValues));


    }

}
