/*
 * $Id: Customer.java,v 1.7 2000/10/04 02:01:07 vijaysr Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */

package com.sun.j2ee.blueprints.customer.customer.ejb;

import java.util.Collection;
import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.DuplicateKeyException;

import com.sun.j2ee.blueprints.customer.account.model.AccountModel;
import com.sun.j2ee.blueprints.customer.util.ContactInformation;
import com.sun.j2ee.blueprints.customer.order.model.OrderModel;
import com.sun.j2ee.blueprints.customer.order.ejb.Order;
import com.sun.j2ee.blueprints.customer.account.ejb.Account;
import com.sun.j2ee.blueprints.customer.util.Address;
import com.sun.j2ee.blueprints.customer.util.CreditCard;

/**
 * This is the session facade for the customer component. This is implemented
 * as a session bean which exports interfaces of the Account and order
 * components
 */

public interface Customer extends EJBObject {

    /**
     * @return the account information corresponding to a customer's account.
     */
    public AccountModel getAccountDetails()
        throws RemoteException;

    /**
     * updates the contact information  for the specified account
     */
    public void changeContactInformation(ContactInformation info)
        throws RemoteException;

    /**
     * Create interface of AccountHome component
    */
    public boolean createAccount(String userId,
                          String status, ContactInformation info)
        throws RemoteException;

    /**
     * Return the details of an order
    */
    public OrderModel getOrderDetails(int orderId)
        throws RemoteException;

    /**
     * Create interface of Order component
    */
    public int createOrder(Collection lineItems, Address shipToAddr,
                        Address billToAddr,  String shipToFirstName,
                        String shipToLastName, String billToFirstName,
                        String billToLastName, CreditCard chargeCard,
                        String carrier, double totalPrice)
        throws RemoteException;
}
