/*
 * $Id: AccountWebImpl.java,v 1.8 2000/10/09 03:13:31 inder Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */

package com.sun.j2ee.blueprints.petstore.control.web;

import java.rmi.RemoteException;
import javax.ejb.FinderException;

import com.sun.j2ee.blueprints.petstore.util.JNDINames;
import com.sun.j2ee.blueprints.customer.account.model.AccountModel;
import com.sun.j2ee.blueprints.customer.customer.ejb.Customer;
import com.sun.j2ee.blueprints.petstore.control.web.ModelManager;
import com.sun.j2ee.blueprints.petstore.control.web.ModelUpdateListener;
import com.sun.j2ee.blueprints.petstore.control.ejb.ShoppingClientController;

/**
 * This class is the web-tier representation of the Account.
 */
public class AccountWebImpl extends AccountModel
    implements ModelUpdateListener {

    private ModelManager mm;
    private Customer custEjb;

    public AccountWebImpl() {
        super(null, null, null);
    }

    public AccountWebImpl(ModelManager mm) {
        super(null, null, null);
        this.mm = mm;
        mm.addListener(JNDINames.CUSTOMER_EJBHOME, this);
    }

    public void performUpdate() {
        // Get data from the EJB
        if (custEjb == null) {
            custEjb = mm.getCustomerEJB();
        }
        if (custEjb != null) {
            try {
                copy(custEjb.getAccountDetails());
            } catch(RemoteException re) {
            }
        }
    }
}

