/*
 * $Id: ProfileMgrModel.java,v 1.9 2000/10/05 16:24:39 lblair Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */

package com.sun.j2ee.blueprints.petstore.personalize.profilemgr.model;

import com.sun.j2ee.blueprints.petstore.personalize.util.ExplicitInformation;
import com.sun.j2ee.blueprints.petstore.personalize.profilemgr.ejb.ProfileMgrDAO;
import com.sun.j2ee.blueprints.petstore.personalize.profilemgr.ejb.ProfileMgrDAOException;
import com.sun.j2ee.blueprints.util.tracer.Debug;

/**
 * This class provides methods to view and modify personalization profile
 * information for a particular user.
 */
public class ProfileMgrModel implements java.io.Serializable {

    private String userId;
    private ExplicitInformation eInfo;

    public ProfileMgrModel(String userId, ExplicitInformation eInfo) {
        this.userId = userId;
        this.eInfo = eInfo;
    }

    public ProfileMgrModel() {}

    // get and set methods for the instance variables
    public String getUserId() {
        return userId;
    }

    public ExplicitInformation getExplicitInformation() {
        return eInfo;
    }

   public String getBanner(String favCategory) throws Exception {
       try {
            ProfileMgrDAO dao = new ProfileMgrDAO();
            return dao.getBanner(favCategory);
        } catch (ProfileMgrDAOException se) {
            throw new Exception(se.getMessage());
        }
    }

    /** shallow copy */
    public void copy(ProfileMgrModel other) {
        this.userId = other.userId;
        this.eInfo = other.eInfo;
    }
}
