/*
 * $Id: ProductDetailsTag.java,v 1.2 2000/10/03 05:10:33 gmurray Exp $
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs.
 */

package com.sun.j2ee.blueprints.petstore.taglib;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.IOException;
import java.util.Locale;

import com.sun.j2ee.blueprints.shoppingcart.catalog.model.Item;
import com.sun.j2ee.blueprints.shoppingcart.catalog.model.Product;
import com.sun.j2ee.blueprints.petstore.control.web.CatalogWebImpl;
import com.sun.j2ee.blueprints.petstore.util.WebKeys;

/*
 * ProductDetailsTag
 * -----------------
 */

public class ProductDetailsTag extends BodyTagSupport {
        private Item item = null;
        private Product product = null;

        public int doStartTag() throws JspTagException {

                CatalogWebImpl catalog = (CatalogWebImpl)
                pageContext.getServletContext().getAttribute(WebKeys.CatalogModelKey);
                if (catalog == null) {
                        throw new JspTagException("ProductDetailsTag : catalog is null");
                }
                Locale locale = (Locale)
                        pageContext.getSession().getAttribute(WebKeys.LanguageKey);
                if (locale == null)
                        locale = Locale.US;

                try {
                        item = catalog.getItem(
                                pageContext.getRequest().getParameter("item_id"), locale);
                        if(item == null)
                                throw new JspTagException("ProductDetailsTag : item is null");
                        product = catalog.getProduct(item.getProductId(), locale);
                        if(product == null)
                                throw new JspTagException("ProductDetailsTag:product is null");
                } catch (Exception e) {
                        throw new JspTagException("Exception while getting product " + e);
                }

                return(EVAL_BODY_TAG);
        }

        public int doEndTag() {
                try {
                        BodyContent body = getBodyContent();
                        if (body != null) {
                                JspWriter out = body.getEnclosingWriter();
                                out.print(body.getString());
                        }
                } catch(IOException ioe) {
                        System.out.println("Error handling items tag: " + ioe);
                }
                return(SKIP_BODY);
        }

        public Object getCurrentItem() {
                return (Object)item;
        }

        public Object getCurrentProduct() {
                return (Object)product;
        }
}
